////////////////////////////////////////////////////////////////////// 
// PreMeta.cpp 
// (c) 2012-2013 Shuang Feng, Dajiang Liu, Goncalo Abecasis
// 
// This file is distributed as part of the RareMetalWorker source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile RareMetalWorker.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
// Wednesday November 28, 2012
// 

#ifndef __PREMETA_H__
#define __PREMETA_H__

#include "FastFit.h"
#include "VcfRecord.h"
#include "VcfFileReader.h"
#include "VcfHeader.h"

class PreMeta
{
    public:
        PreMeta();
        ~PreMeta();
        static bool vcfAnnotated;
	
	//Input/Output options	
	static String vcfInput;
	static String outputFile;
	static int Xstart,Xend;
	static String xLabel;
	static bool dosage;
	static bool genoFromPed;
	static bool genoFromVCF;
	static bool FounderFreq;
	static int window;
	static int maleLabel;
	static int femaleLabel;

	int numFounders;

	VcfFileReader reader;
	VcfHeader header;
	VcfRecord record;

	//this is the position of each marker in a gene for output
	int pos,hom1,het,hom2;
	double founderMaf,markerMaf,callRate;
	String chr,refAllele,rareAllele;
	double mac,hwe_pvalue;
	Vector genotype;
	Vector chisqred;
	double lambda;

	void Run(FILE * SCOREoutput,FILE * SCOREcov,Pedigree & ped, FastTransform & trans,FastFit & engine, String & traitName,FILE * log);
	void VCFSanityCheck();
	bool GetGenotypeVectorVCFDosage(FastTransform & trans, Pedigree & ped);
	bool GetGenotypeVectorVCF(FastTransform & trans, Pedigree & ped);
	int GetGenotypeVectorPED(FastTransform & trans, Pedigree & ped,int markerid,FILE *log);
	//bool GetGenotypeVector(FastTransform & trans, Pedigree & ped,int markerid);
	void PrintHeader(FILE * output,FastFit & engine,FastTransform & trans,Pedigree & ped);
	double CalculateCov(FastFit & engine,FastTransform & trans, Pedigree & ped, Matrix & genotypeAl,Vector & sigma2,int m);
};

#endif
